unit uChartSettings;

interface

uses
  Chart;

procedure InitChart(aChart: TChart);

implementation

uses
  Graphics, TeEngine, Controls, Classes, Forms;

type
  TChartControl = class
    class procedure ChartClickAxis(Sender: TCustomChart; Axis: TChartAxis;
              Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  end;

  class procedure TChartControl.ChartClickAxis(Sender: TCustomChart; Axis: TChartAxis;
              Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  begin
    with Sender do begin
      if Axis = LeftAxis then begin
        LeftAxis.Grid.Visible:= True;
        RightAxis.Grid.Visible:= False;
      end;
      if Axis = RightAxis then begin
        LeftAxis.Grid.Visible:= False;
        RightAxis.Grid.Visible:= True;
      end;
    end;
  end;

procedure InitAxis(aAxis: TChartAxis);
begin
  aAxis.Axis.Width:= 1;
  aAxis.AxisValuesFormat:= '0.#####';
  aAxis.Grid.Color:= clPurple;
  aAxis.Grid.SmallDots:= True;
  aAxis.Increment:= 0.00001;
  aAxis.LabelStyle:= talValue;
  aAxis.LabelsSeparation:= 10;
  aAxis.LabelsOnAxis:= True;
  aAxis.MinorTicks.Visible:= False;
  aAxis.StartPosition:= 1;
  aAxis.EndPosition:= 99;
  aAxis.TickInnerLength:= 4;
  aAxis.TicksInner.Width:= 1;
  aAxis.TickLength:= 2;
  aAxis.Ticks.Width:= 1;
end;

procedure InitChart(aChart: TChart);
begin
  aChart.Title.Visible:= False;
  //aChart.Frame.SmallDots:= True;
  InitAxis(aChart.BottomAxis);
  //aChart.BottomAxis.LabelsSeparation:= 30;
  aChart.BottomAxis.LabelsSeparation:= 100;
  InitAxis(aChart.LeftAxis);
  aChart.OnClickAxis:= TChartControl.ChartClickAxis;
  InitAxis(aChart.RightAxis);
  aChart.RightAxis.Grid.Visible:= False;
  aChart.TopAxis.Visible:= False;
  aChart.View3D:= False;
  aChart.BevelOuter:= bvNone;
  aChart.BorderStyle:= bsNone; // bsSingle;
end;

end.
