unit uGUIUtils;

interface

uses
  Forms,
  Controls;

type
  TScaledForm = class(TForm)
  protected
    procedure ChangeScale(M, D: Integer); override;
  end;

  TChangeScaleData = array of TAnchors;

procedure BeginChangeScale(aControl: TWinControl; var aData: TChangeScaleData);
procedure EndChangeScale(aControl: TWinControl; var aData: TChangeScaleData);

implementation

uses
  Windows;

type
  TScrollWinCtrl = class(TScrollingWinControl)
  published
    property AutoScroll;
  end;

procedure BeginChangeScale(aControl: TWinControl; var aData: TChangeScaleData);
var j: Integer;
  procedure AddControls(aCtrl: TWinControl);
  var i: Integer;
  begin
    if aCtrl is TScrollingWinControl then
      TScrollWinCtrl(aCtrl).AutoScroll:= False;
    with aCtrl do begin
      SetLength(aData, Length(aData) + ControlCount);
      for i:= 0 to ControlCount - 1 do begin
        aData[j]:= Controls[i].Anchors;
        Inc(j);
        Controls[i].Anchors:= [akLeft, akTop];
        if Controls[i] is TWinControl then
          AddControls(TWinControl(Controls[i]));
      end;
    end;
  end;
begin
  aData:= nil;
  j:= 0;
  AddControls(aControl);
end;

procedure EndChangeScale(aControl: TWinControl; var aData: TChangeScaleData);
var j: Integer;
  procedure SetControls(aCtrl: TWinControl);
  var i: Integer;
  begin
    with aCtrl do begin
      for i:= 0 to ControlCount - 1 do begin
        Controls[i].Anchors:= aData[j];
        Inc(j);
        if Controls[i] is TWinControl then
          SetControls(TWinControl(Controls[i]));
      end;
    end;
  end;
begin
  j:= 0;
  SetControls(aControl);
  aData:= nil;
end;

procedure TScaledForm.ChangeScale(M, D: Integer);
var
  aData: TChangeScaleData;
begin
  BeginChangeScale(Self, aData);
  inherited ChangeScale(M, D);
  EndChangeScale(Self, aData);
end;

end.
